Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## rice.p2p.replication.manager
Interface ReplicationManagerClient

All Known Implementing Classes:
  GCPastImpl, PastImpl, ReplicationManagerRegrTest.TestReplicationManagerClient

    public interface ReplicationManagerClient

Version:
  $Id: ReplicationManagerClient.java 3613 2007-02-15 14:45:14Z jstewart $
Author:
  Alan Mislove

Method Summary
`boolean` | `exists(Id id)` This upcall should return whether or not the given id is currently stored locally by the client.
`void` | `existsInOverlay(Id id, Continuation command)` This upcall should return whether or not the given id is currently stored somewhere in the overlay by the client.
`void` | `fetch(Id id, NodeHandle hint, Continuation command)` This upcall is invoked to tell the client to fetch the given id, and to call the given command with the boolean result once the fetch is completed.
`void` | `reInsert(Id id, Continuation command)` Asks a client to reinsert an object it already holds into the overlay
`void` | `remove(Id id, Continuation command)` This upcall is to notify the client that the given id can be safely removed from the storage.
`IdSet` | `scan(IdRange range)` This upcall should return the set of keys that the application currently stores in this range.

Method Detail

### fetch

    void fetch(Id id,
               NodeHandle hint,
               Continuation command)

  This upcall is invoked to tell the client to fetch the given id, and to call the given command with the boolean result once the fetch is completed. The client *MUST* call the command at some point in the future, as the manager waits for the command to return before continuing.

  Parameters:
    `id` - The id to fetch
    `hint` - A hint where to find the key from. This is where the local node heard about the key.
    `command` - The command to return the result to

### remove

    void remove(Id id,
                Continuation command)

  This upcall is to notify the client that the given id can be safely removed from the storage. The client may choose to perform advanced behavior, such as caching the object, or may simply delete it.

  Parameters:
    `id` - The id to remove

### scan

    IdSet scan(IdRange range)

  This upcall should return the set of keys that the application currently stores in this range. Should return a empty IdSet (not null), in the case that no keys belong to this range.

  Parameters:
    `range` - the requested range

### exists

    boolean exists(Id id)

  This upcall should return whether or not the given id is currently stored locally by the client.

  Parameters:
    `id` - The id in question
  Returns:
    Whether or not the id exists

### existsInOverlay

    void existsInOverlay(Id id,
                         Continuation command)

  This upcall should return whether or not the given id is currently stored somewhere in the overlay by the client.

  Parameters:
    `id` - The id in question

### reInsert

    void reInsert(Id id,
                  Continuation command)

  Asks a client to reinsert an object it already holds into the overlay

  Parameters:
    `id` - The id in question

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Rice Pastry API
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2005 - Rice Pastry.